"use strict";

/*************************************************************************************************/
/* Custom variables - divs are automatically made into vars in vars.min.js ***********************/
/*************************************************************************************************/

var tl = gsap.timeline(),
	buttonArray, button, disabledArray, disabledButton, clickthroughArray, clickthroughButton, type,
	i, j;


	// var currentDate = Date.now(), date = new Date(2021, 0, 5);
	// var currentDate = Date.now(), date = new Date(2020, 11, 4);


	/*************************************************************************************************/
/* DYNAMIC CONTENT SAMPLE VALUES *******************************************/
/*************************************************************************************************/

function setDynamicContent(){

    Enabler.setProfileId(10590605);
    var devDynamicContent = {};

	devDynamicContent.BT_JAN_SALE_2021_Sheet1 = [{}];
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0]._id = 0;
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Unique_ID = 1;
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Reporting_Label = "BT_JAN_SALE_120X600";
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].bannerConfig = "";
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Start_Date = {};
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Start_Date.RawValue = "2020-12-08 0:00:00";
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Start_Date.UtcValue = 1607385600000;
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].End_Date = {};
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].End_Date.RawValue = "2021-1-29 23:59:00";
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].End_Date.UtcValue = 1608767940000;
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].weight = 100;
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Exit_URL = {};
	devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].Exit_URL.Url = "https://www.bt.com/broadband/deals";
	devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].product = "Superfast Fibre";
	devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].pricing = "£24 <span class='sup'>.99<br><span class='fs17'>/month</span></span>";
	devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].months = "24 months";
    devDynamicContent.BT_JAN_SALE_2021_Sheet1[0].isActive = true;
	Enabler.setDevDynamicContent(devDynamicContent);
	

	console.log('setting dynamic data')


	productCopy.innerHTML 		= dynamicContent.BT_JAN_SALE_2021_Sheet1[0].product;
	pricingCopy.innerHTML 		= dynamicContent.BT_JAN_SALE_2021_Sheet1[0].pricing;
	monthsCopy.innerHTML 		= dynamicContent.BT_JAN_SALE_2021_Sheet1[0].months;
	bannerConfig.innerHTML 		= dynamicContent.BT_JAN_SALE_2021_Sheet1[0].bannerConfig;	

		if (dynamicContent.BT_JAN_SALE_2021_Sheet1[0].bannerConfig == "countdown") {
			createTimeline2()
			console.log('::playing time line 2 with countdown::')
			TweenMax.delayedCall(1.2, function() { 
				introVideo.src = getVideoUrl("video/video.mp4");
				introVideo.load();
				
			});
		} else {
			createTimeline1()
			console.log('::playing time line 1 without countdown::')
			TweenMax.delayedCall(1.2, function() { 
				introVideo.src = getVideoUrl("video/video.mp4");
				introVideo.load();
			
			});
			
		}

}


/*************************************************************************************************/
/* Banner initialisation, loading, event listening etc *******************************************/
/*************************************************************************************************/

function init() {

	addEventListeners();
	// checkingDate();

	
	(Enabler.isPageLoaded()) ? politeInit() : Enabler.addEventListener(studio.events.StudioEvent.PAGE_LOADED, politeInit);

	Enabler.loadModule(studio.module.ModuleId.VIDEO, function() {
		studio.video.Reporter.attach("introVideo", introVideo);
	});

	countDownClock();
	getOS();
}

function addEventListeners() {
	buttonArray = [container];
	for (i = 0; i < buttonArray.length; i++) {
		button = buttonArray[i];
		button.style.cursor = "pointer";
		button.addEventListener("mouseover", buttonHandler, false);
		button.addEventListener("mouseout", buttonHandler, false);
		button.addEventListener("click", buttonHandler, false);
	}

	disabledArray = [];
	for (i = 0; i < disabledArray.length; i++) {
		disabledButton = disabledArray[i];
		disabledButton.style.pointerEvents = "none";
	}
}

function politeInit() {
	console.log(":: starting polite load ::");

	setDynamicContent();

	setTimeout(function() {
		politeLoad([
			{url:"images/hublogo.png", div:"hubLogo"},
			{url:"images/copy1.png", div:"copy1"},
			{url:"images/copy2.png", div:"copy2"},
			{url:"images/copy3.png", div:"copy3"},
			{url:"images/cta.png", div:"cta"},
			{url:"images/logo.png", div:"logo"},
			{url:"images/timerheadline.png", div:"timeHeadline"},
			// {url:"images/970x250_preview.jpg", div:"preview"},
		],

		function() {
			console.log(":: all loads complete ::");
			// gsap.delayedCall(0.2, function() { tl.play(); });
		});
	}, 100);
}




// function checkingDate() {
// 	if (currentDate >= date) {
// 		createTimeline2()
// 		console.log('playing time line 2')
// 		TweenMax.delayedCall(1.2, function() { 
// 			introVideo.src = getVideoUrl("video/video.mp4");
// 			introVideo.load();
			
// 		});
// 	} else {
// 		createTimeline1()
// 		console.log('playing time line 1')
// 		TweenMax.delayedCall(1.2, function() { 
// 			introVideo.src = getVideoUrl("video/video.mp4");
// 			introVideo.load();
		
// 		});
		
// 	}
// }




function playVid() {
	if (introVideo.readyState === 4 ) {
		introVideo.play();
	} else {
		setTimeout(function() { playVid(); }, 100);
	}
}


function getVideoUrl($filename) {
    if (Enabler.isServingInLiveEnvironment()) {
        return Enabler.getUrl($filename); 
    } else {
        return $filename;
    }
}


/*************************************************************************************************/
/* Timeline & any other animation & logic ********************************************************/
/*************************************************************************************************/

function createTimeline1() {


	playVid()

		tl


		.set ([clockdiv, timeHeadline], {autoAlpha:0}, 0)
		.set([infoContainer, hubLogo], {autoAlpha:0}, 0)

		.addLabel("start")
		.to(preloader, {duration:0.2, autoAlpha:0, ease:"quad.inOut", overwrite:false}, "start")
		.set([infoContainer, hubLogo], {autoAlpha:1}, "start+=0.2")

		.addLabel("animateFrame1", 0.5)

		.from(copy1, {duration:0.5, autoAlpha:0, y:20, ease:"quad.inOut"}, "animateFrame1")

		.addLabel("animateFrame2", 2.5)

		.to(copy1, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame2")
		.from(copy2, {duration:0.5, autoAlpha:0, y:20, ease:"quad.inOut"}, "animateFrame2+=0.5")

		.addLabel("animateFrame3", 4.5)

		.set(copy1, {y:20}, "animateFrame3")
		.to(copy2, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame3")
		.from(copy3, {duration:0.5, autoAlpha:0, y:20, ease:"quad.inOut"}, "animateFrame3+=0.5")
		

		.addLabel("animateFrame4", 6.5)

		.set(copy2, {y:20}, "animateFrame4")
		.to(copy3, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame4")
		.to(copy1, {duration:0.5, autoAlpha:1, y:0, ease:"quad.inOut"}, "animateFrame4+=0.5")

		.addLabel("animateFrame5", 8.5)
		.set(copy3, {y:20}, "animateFrame5")
		.to(copy1, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame5")
		.to(copy2, {duration:0.5, autoAlpha:1, y:0, ease:"quad.inOut"}, "animateFrame5+=0.5")
	

		.addLabel("animateFrame6", 10.5)
		.to(copy2, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame6")
		.to(copy3, {duration:0.5, autoAlpha:1, y:0, ease:"quad.inOut"}, "animateFrame6+=0.5")

		.addLabel("end" , 12)
	

        .pause();

		}



function createTimeline2() {

		playVid();
		
		tl

		.set([copy3], {autoAlpha:0}, 0)
		.set([infoContainer, hubLogo], {autoAlpha:0}, 0)
		
		.addLabel("start")
		.to(preloader, {duration:0.35, autoAlpha:0, ease:"quad.inOut", overwrite:false}, "start")
		.set([infoContainer, hubLogo], {autoAlpha:1}, "start+=0.3")
		
		.addLabel("animateFrame1", 0.5)
		
		.from(copy1, {duration:0.5, autoAlpha:0, y:50, ease:"quad.inOut"}, "animateFrame1")
		
		.addLabel("animateFrame2", 2.5)
		
		.to(copy1, {duration:0.5, autoAlpha:0, y:-50, ease:"quad.inOut"}, "animateFrame2")
		.from(copy2, {duration:0.5, autoAlpha:0, y:50, ease:"quad.inOut"}, "animateFrame2+=0.5")
		
		
		.addLabel("animateFrame3", 4.5)
		.to(infoContainer, {duration:0.5, autoAlpha:0, ease:"quad.inOut"}, "animateFrame3")
		.from([clockdiv, timeHeadline], {duration:0.5, autoAlpha:0, ease:"quad.inOut"}, "animateFrame3+=0.5")

		.set(copy1, {y:20}, "animateFrame3")
		.to(copy2, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame3")
		.to(pricingCopy, {duration:0.5, autoAlpha:0, ease:"quad.inOut"}, "animateFrame3")
		// .from(clockdiv, {duration:0.5, autoAlpha:0, ease:"quad.inOut"}, "animateFrame3+=0.5")

		.addLabel("animateFrame4", 5)

		.set(copy2, {y:20}, "animateFrame4")
		.to(copy1, {duration:0.5, autoAlpha:1, y:0, ease:"quad.inOut"}, "animateFrame4")
	

		.addLabel("animateFrame5", 6.5)

		.to(copy1, {duration:0.5, autoAlpha:0, y:-20, ease:"quad.inOut"}, "animateFrame5")
		.to(copy2, {duration:0.5, autoAlpha:1, y:0, ease:"quad.inOut"}, "animateFrame5+=0.5")

		.addLabel("end" , 12)
				
			
		
		.pause();
		
		}
		



/*************************************************************************************************/
/* CUE POINTS *************************************************************************************/
/*************************************************************************************************/


var cuePoints = [{"point":0.1,"fired":false},{"point":3.00,"fired":false},{"point":8.02,"fired":false}];  
var onRender = function(){
  if (!introVideo.paused) {
	// console.log(creative.dom.video0.vid.currentTime);

	if (introVideo.currentTime > cuePoints[0].point && cuePoints[0].fired === false) {
	  cuePoints[0].fired = true;
	  console.log( "::Timeline Start::");
	  tl.play('start');
	} 
	// else if 
	// (introVideo.currentTime > cuePoints[1].point && cuePoints[1].fired === false) {
	//   cuePoints[1].fired = true;
	//   console.log( "frame1");
	//   tl.play('label1');
	// } 
	// else if 
	// (introVideo.currentTime > cuePoints[2].point && cuePoints[2].fired === false) {
	//   cuePoints[2].fired = true;
	//   console.log(  "frame2");
	//  tl.play('label2');
	// }
	// else if 
	// (creative.dom.video0.vid.currentTime > cuePoints[3].point && cuePoints[3].fired === false) {
	//   cuePoints[3].fired = true;
	//   console.log("frame3");
	//   creative.tl.play('label3');
	// }  
	// else if 
	// (creative.dom.video0.vid.currentTime > cuePoints[4].point && cuePoints[4].fired === false) {
	//   cuePoints[4].fired = true;
	//   console.log("frame4");
	//   creative.tl.play('label4');
	// } 
	// else if 
	// (creative.dom.video0.vid.currentTime > cuePoints[5].point && cuePoints[5].fired === false) {
	//   cuePoints[5].fired = true;
	//   console.log("frame5");
	//   creative.tl.play('label5');
	// } 
  }  
requestAnimationFrame(onRender);
}
requestAnimationFrame(onRender);


/*************************************************************************************************/
/* COUNTDOWN TIMER *******************************************************************************/
/*************************************************************************************************/

function countDownClock() {
	var safariDate;
	
	if (navigator.userAgent.indexOf('Safari') != -1 && navigator.userAgent.indexOf('Chrome') == -1) {
		safariDate = new Date(dynamicContent.BT_JAN_SALE_2021_Sheet1[0].End_Date.RawValue.replaceAll("-", "/")).getTime();
	} else {
		safariDate = new Date(dynamicContent.BT_JAN_SALE_2021_Sheet1[0].End_Date.RawValue).getTime();
	}


	const 	countDownDate 		= safariDate,
	// const 	countDownDate 		= new Date("Jan 29, 2021 00:00:0").getTime(),
			daysSpan 			= clockdiv.querySelector(".days"),
			hoursSpan 			= clockdiv.querySelector(".hours"),
			minutesSpan 		= clockdiv.querySelector(".minutes"),
			secondsSpan 		= clockdiv.querySelector(".seconds");
	
	var interval = setInterval(function() {
		var now 				= new Date().getTime(),
			// now 				= new Date("Dec 7, 2020 12:00:0").getTime(),
		
			distance 			= countDownDate - now,
		
			days 				= Math.floor(distance / (1000 * 60 * 60 * 24)),
			hours 				= Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)),
			minutes 			= Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60)),
			seconds 			= Math.floor((distance % (1000 * 60)) / 1000),
		
			fixedDays 			= (days.toString().length === 1) ? fixedDays = "0" + days : days,
			fixedHours 			= (hours.toString().length === 1) ? fixedHours = "0" + hours : hours,
			fixedMinutes 		= (minutes.toString().length === 1) ? fixedMinutes = "0" + minutes : minutes,
			fixedSeconds 		= (seconds.toString().length === 1) ? fixedSeconds = "0" + seconds : seconds;
	
		
		daysSpan.innerHTML 		= fixedDays.toString();
		hoursSpan.innerHTML 	= fixedHours.toString();
		minutesSpan.innerHTML 	= fixedMinutes.toString();
		secondsSpan.innerHTML 	= fixedSeconds.toString();
	
		if (distance <= 0) {
			clearInterval(interval);
		}
	}, 1000);
}


function getOS() {
	var userAgent = window.navigator.userAgent,
		platform = window.navigator.platform,
		macosPlatforms = ['Macintosh', 'MacIntel', 'MacPPC', 'Mac68K'],
		windowsPlatforms = ['Win32', 'Win64', 'Windows', 'WinCE'],
		iosPlatforms = ['iPhone', 'iPad', 'iPod'],
		os = null;
  
	if (macosPlatforms.indexOf(platform) !== -1) {
	  os = 'Mac OS';
	} else if (iosPlatforms.indexOf(platform) !== -1) {
	  os = 'iOS';
	} else if (windowsPlatforms.indexOf(platform) !== -1) {
	  os = 'Windows';
	  gsap.set(pricingCopy, {y:5});
	  gsap.set(".sup", {y:-5});
	//   document.getElementsByClassName("sup").style.top = "11px";
	  console.log('WINDOWS');
	} else if (/Android/.test(userAgent)) {
	  os = 'Android';
	} else if (!os && /Linux/.test(platform)) {
	  os = 'Linux';
	}
  
	return os;
  }

/*************************************************************************************************/
/* Event handlers ********************************************************************************/
/*************************************************************************************************/



function buttonHandler($e) {
	button 	= $e.currentTarget;
	type	= $e.type;

	switch (button) {
		case container:
			if 		(type === "mouseover") 	{  }
			else if (type === "mouseout") 	{  }
			else if (type === "click") 		{ Enabler.exitOverride("banner_clickthrough", dynamicContent.BT_JAN_SALE_2021_Sheet1[0].Exit_URL.Url); introVideo.pause(), introVideo.currentTime = 15, tl.play("end")} //comment out if standard
			// else if (type === "click") 		{ Enabler.exit("BG Exit", ""); introVideo.pause(), introVideo.currentTime = 15, tl.play("end")} //uncomment if standard
			break;
	}
}


/*************************************************************************************************/
/* Check page and Enabler has been loaded and initialised ****************************************/
/*************************************************************************************************/

function checkEnabler() {
	(Enabler.isInitialized()) ? enablerInitHandler() : Enabler.addEventListener(studio.events.StudioEvent.INIT, enablerInitHandler);
}

function enablerInitHandler() {
	(Enabler.isVisible()) ? init() : Enabler.addEventListener(studio.events.StudioEvent.VISIBLE, init);
}

domready(function() {
	console.log(":: dom ready ::");
	if (elementScrape()) checkEnabler();
});