
// --------------------------------------------------------------------------------------------------

// SETUP VARIABLES

var standalone = true;
var preloadShape = document.getElementById('preloadShape');
var mainContainer = document.getElementById('main-container');
var videoContainer = document.getElementById('video-container');
var video = document.getElementById('video');
var headContainer = document.getElementById('headline-container');
var headbarS = document.getElementById('headbar-s')
var headbar1 = document.getElementById('headbar1');
var headbar2 = document.getElementById('headbar2');
var headbar3 = document.getElementById('headbar3');
var headbar4 = document.getElementById('headbar4');
var headArrow = document.getElementById('headline-arrow');
var text1 = document.getElementById('text1');
var text2 = document.getElementById('text2');
var text3 = document.getElementById('text3');
var text4 = document.getElementById('text4');
var text5 = document.getElementById('text5');
var text6 = document.getElementById('text6');
var endFrame = document.getElementById('end-frame');
var cta = document.getElementById('cta');
var logoText1 = document.getElementById('logoText1');
var logoText2 = document.getElementById('logoText2');
var barTop = document.getElementById('barTop');
var barBot = document.getElementById('barBot');
var logoContainer = document.getElementById('logoContainer');
var logoEnd = document.getElementById('logo-end');
var frame1;
var frame2;
var endframe;



var tl = new TimelineMax({paused:true});



// --------------------------------------------------------------------------------------------------

// INITIALISE GOOGLE STUDIO COMPONENTS

window.addEventListener('load', initStudio);

function initStudio() {
	
	if (Enabler.isInitialized()) {
		checkVisibility();
	} else {
		Enabler.addEventListener(studio.events.StudioEvent.INIT, checkVisibility);
	}
}


function checkVisibility() {

	if (Enabler.isVisible()) {
		init();
	} else {
		Enabler.addEventListener(studio.events.StudioEvent.VISIBLE, init);
	}
}



// --------------------------------------------------------------------------------------------------

//  INIT

function init() {
	
	//loadConfig();
	addVideoTracking();
	addListeners();
	
	
	tl.addLabel('start', 0)
		.set(headArrow, {x:40, autoAlpha:0})
		.set(endFrame, {y:600})
		.set(text5, {autoAlpha:1})

		.to(preloadShape, 0.5, {autoAlpha:0})

	.addLabel('label1', 1.00)      
		.to(headArrow, 0.5, {autoAlpha:1, x:0, ease: Back.easeOut}, 'label1')  
		.to(['#headbar1', '#text1'], 0.5, {minWidth:218, ease: Expo.easeInOut}, 'label1+=0.1')  


	.addLabel('label2', 2.00)  
	.to(headbar1, 0.7, {y:-28, className:"headbar-alpha", ease: Expo.easeInOut}, 'label2')  
	.set(headbar2, {autoAlpha:1}, 'label2')
	.set(headbarS, {autoAlpha:1}, 'label2')
	.to(text2, 0.7, {y:-28, ease: Expo.easeInOut}, 'label2')
	.to(text1, 0.7, {color:'#000', ease: Expo.easeInOut}, 'label2')
	.to("#text1 span", 0.7, {color:'#000', ease: Expo.easeInOut}, 'label2')     

	.addLabel('label3', 3.30)  
	.set(headbar3, {autoAlpha:1}, 'label3')
	.to(text2, 0.5, {y:-52, ease: Expo.easeInOut}, 'label3')
	.to(text3, 0.5, {y:-28, ease: Expo.easeInOut}, 'label3')
      

	.addLabel('label4', 4.70)  
	.set(headbar4, {autoAlpha:1}, 'label4')
	.to(text3, 0.5, {y:-52, ease: Expo.easeInOut}, 'label4')
	.to(text4, 0.5, {y:-28, ease: Expo.easeInOut}, 'label4')
     

	.addLabel('label5', 6.00)
		.to(headContainer, 0.5, {y:-600, ease: Expo.easeInOut}, 'label5')
		.to(endFrame, 0.5, {y:0, ease: Expo.easeInOut}, 'label5')
		.to(barTop, 0.5, {autoAlpha:1}, 'label5+=1.0')
		.to(barBot, 0.5, {autoAlpha:1}, 'label5+=1.0')
		.to(logoEnd, 0.5, {autoAlpha:1}, 'label5+=1.0')
		.to(logoText1, 0.3, {x:157}, 'label5+=1.5')
		.to(logoText2, 0.3, {x:167}, 'label5+=1.6')

		.to(cta, 0.5, {autoAlpha:1, ease: Linear.easeNone}, 'label5+=2.0') 
		.to(text6, 0.5, {autoAlpha:1, ease: Linear.easeNone}, 'label5+=2.0') 
		//.to('#dummy', 0, {autoAlpha:0}, 'label5+=3.0');

	
	setTimeout(delayedStart, 1000);

}



function delayedStart(){
	
	console.log('delayedStart');
	console.log('standalone: ' + standalone);
	
	if (standalone){
		video.play();
		TweenMax.ticker.addEventListener('tick', tlUpdate);
	}
}



// --------------------------------------------------------------------------------------------------

// --------------------------------------------------------------------------------------------------

// EVENT LISTENERS

function addListeners() {
	
	console.log('addListeners');
	
	video.addEventListener('ended', startMutedvideoEndHandler, false);

	mainContainer.addEventListener('click', exitClickHandler);
	
	mainContainer.addEventListener('mouseover', function () {
		TweenLite.to(cta, 0.3, {backgroundColor: '#003EA9'})
	});
	
	mainContainer.addEventListener('mouseout', function () {
		TweenLite.to(cta, 0.3, {backgroundColor: '#1A1F71'})
	});
	
}





// --------------------------------------------------------------------------------------------------

// SYNC TIMELINE TO VIDEO

function tlUpdate() {
	//console.log('tlUpdate');
	tl.progress(video.currentTime / video.duration);
}





// --------------------------------------------------------------------------------------------------

// EVENT HANDLING

function exitClickHandler() {
	
	// Reset video
	video.pause();
	if (video.readyState > 0) {
		video.currentTime = video.duration;
		tl.seek(tl.duration(), false);
		logoEnd.style.opacity = 1;

	}
	Enabler.exit('BackgroundExit');
}


// Triggered once the video player is ready to play the video.

function startMuted(e) {
	// Leaving the listener can cause issues on Chrome / Firefox
	if (video.hasCanPlay) {
		video.removeEventListener('canplay', startMuted);
		video.hasCanPlay = false;
	}
	// If paused then play
	video.volume = 0; // Muted by default
	video.currentTime = 0;
	video.play();
}


// Stops the video.

function stopHandler(e) {
	Enabler.counter("Video stopped", true);
	video.currentTime = 0;
	video.pause();
}


// Handler triggered when the video has finished playing.

function startMutedvideoEndHandler(e) {
	video.currentTime = video.duration;
	video.pause();
}

function addVideoTracking() {

	Enabler.loadModule(studio.module.ModuleId.VIDEO, function() {
		studio.video.Reporter.attach('video', video);
	});
}
