
// Reference to the creative's various properties and elements.
var creative = {};

var videoLength = 10;

/**
 * Called on the window load event.
 */
function preInit() {
  setupDom();

  if (Enabler.isInitialized()) {
    init();
  } else {
    Enabler.addEventListener(
      studio.events.StudioEvent.INIT,
      init
    );
  }
}

/**
 * Set up references to DOM elements.
 */
function setupDom() {
  creative.dom = {};
  creative.dom.preloadShape = document.getElementById('preloadShape');
  creative.dom.mainContainer = document.getElementById('main-container');
  creative.dom.poster = document.getElementById('poster');
  creative.dom.label = document.getElementById('label');
  creative.dom.copyBlock = document.getElementById('copyBlock');
  creative.dom.timerDiv = document.getElementById('timerDiv');
  creative.dom.video0 = {};
  creative.dom.video0.vidContainer = document.getElementById('video-container-0');
  creative.dom.video0.vid          = document.getElementById('video-0');
  creative.dom.text1 = document.getElementById('text1');
  creative.dom.text2 = document.getElementById('text2');
  creative.dom.text3 = document.getElementById('text3');
  creative.dom.cta = document.getElementById('cta');
  creative.dom.barTop = document.getElementById('barTop');
  creative.dom.barBot = document.getElementById('barBot');
  creative.dom.tc = document.getElementById('tc');
  creative.dom.logo = document.getElementById('logo');
  creative.dom.logoContainer = document.getElementById('logoContainer');
  creative.dom.logoEnd = document.getElementById('logoEnd');
}

/**
 * The Enabler is now initialized and any extra modules have been loaded.
 */
function init() {
  // You can update the autoplay flag to 'true' to enable muted
  // autoplay although it won't work on iOS.
  creative.autoplay0 = true;
  creative.isClick0 = false;

  // Hide mute / unmute on iOS.
  if ((navigator.userAgent.match(/iPhone/i)) ||
    (navigator.userAgent.match(/iPad/i)) ||
    (navigator.userAgent.match(/iPod/i))) {
  }

  addVideoTracking0();
  addListeners();
  // Polite loading
  if (Enabler.isVisible()) {
    show();
  }
  else {
    Enabler.addEventListener(studio.events.StudioEvent.VISIBLE, show);
  }
}

/**
 * Add appropriate listeners after the creative's DOM has been set up.
 */
function addListeners() {
  creative.dom.mainContainer.addEventListener('click', exitClickHandler);
  creative.dom.video0.vid.addEventListener('ended', videoEndHandler0, false);
  creative.dom.mainContainer.addEventListener('mouseover', function() {TweenLite.to(cta, 0.3, {backgroundColor:'#003EA9'})});
  creative.dom.mainContainer.addEventListener('mouseout', function() { TweenLite.to(cta, 0.3, {backgroundColor:'#1A1F71'})});
}

/**
 *  Shows the ad.
 */
function show() {
  if (creative.autoplay0) {
    if (creative.dom.video0.vid.readyState >= 2) {
      startMuted0(null);
      // TweenLite.to(creative.dom.preloadShape, 1, {autoAlpha:0});
    }
    else {
      creative.dom.video0.hasCanPlay = true;
      creative.dom.video0.vid.addEventListener('canplay', startMuted0, false);
      // TweenLite.to(creative.dom.preloadShape, 1, {autoAlpha:0});
    }
  }
   
  creative.dom.video0.vidContainer.style.visibility  = 'visible';

  mainTimeline();

  var cuePoints = [{"point":0.1,"fired":false},{"point":1.88,"fired":false},{"point":4.00,"fired":false},{"point":5.00,"fired":false},{"point":6.48,"fired":false},{"point":7.00,"fired":false}];
  var onRender = function(){
    if (!creative.dom.video0.vid.paused) {
      // console.log(creative.dom.video0.vid.currentTime);

      if (creative.dom.video0.vid.currentTime > cuePoints[0].point && cuePoints[0].fired === false) {
        cuePoints[0].fired = true;
        console.log( "Start");
        creative.tl.play('start');
      } 
      else if 
      (creative.dom.video0.vid.currentTime > cuePoints[1].point && cuePoints[1].fired === false) {
        cuePoints[1].fired = true;
        console.log( "Copy 1 Fade In - 0.3sec");
        creative.tl.play('label1');
      } 
      else if 
      (creative.dom.video0.vid.currentTime > cuePoints[2].point && cuePoints[2].fired === false) {
        cuePoints[2].fired = true;
        console.log(  "Copy 1 Fade Out - 0.3sec");
       creative. tl.play('label2');
      }
      else if 
      (creative.dom.video0.vid.currentTime > cuePoints[3].point && cuePoints[3].fired === false) {
        cuePoints[3].fired = true;
        console.log("Copy 2 Fade In - 0.3sec");
        creative.tl.play('label3');
      }  
      else if 
      (creative.dom.video0.vid.currentTime > cuePoints[4].point && cuePoints[4].fired === false) {
        cuePoints[4].fired = true;
        console.log("Copy 2 Fade Out - 0.3sec");
        creative.tl.play('label4');
      } 
      else if 
      (creative.dom.video0.vid.currentTime > cuePoints[5].point && cuePoints[5].fired === false) {
        cuePoints[5].fired = true;
        console.log("Endframe animation start");
        creative.tl.play('label5');
      } 
    }  
  requestAnimationFrame(onRender);
  }
requestAnimationFrame(onRender);
}


// ---------------------------------------------------------------------------------
// FLAG ANIMATION
// ---------------------------------------------------------------------------------

function flagAnimation() {
  console.log('flag');
  var logoBar = document.getElementById('logoBar');
  var logoContainer = document.getElementById('logoContainer');
  
  var barFromDistX = logoContainer.offsetWidth*2.5;
  var barFromDistY = logoContainer.offsetHeight*3;  

  var noLogoBars = 10;  
  logoBar.style.opacity = 0;

  for (var i = 0; i < noLogoBars; i++) {
    var newLogoBar = logoBar.cloneNode(true);
    var newlogoBarOffset = newLogoBar.children[0];

    logoContainer.appendChild(newLogoBar);

    tlBar = new TimelineLite({delay:i/20});
    tlBar.add('start')
      .set(newLogoBar, {opacity: 1},'start')
      .from(newLogoBar, 0.5, {opacity: 0 ,ease: Power2.easeInOut},'start')
      .from(newLogoBar, 1, {x: -barFromDistX, rotation:-210, scale:0.5, ease: Power3.easeOut},'start')
      .from(newlogoBarOffset, 1, {y: -barFromDistY, ease: Power2.easeOut},'start') 
      .set(logoBar, {opacity:1});

    if (i<3){
      tlWipe = new TimelineLite({delay:i/15+1.3});
        tlWipe.add('start')
        .fromTo(newLogoBar, .5, {y:0, opacity: 0},{y: logoContainer.offsetHeight-newLogoBar.offsetHeight, opacity: 1, ease: Power2.easeOut });
    }         
  }

  TweenLite.to(logoImage, .5, {height: logoContainer.offsetHeight, ease: Power2.easeOut, delay: 1.5});


};

// ---------------------------------------------------------------------------------
// MAIN ANIMATION
// ---------------------------------------------------------------------------------
function mainTimeline(){
   creative.tl = new TimelineMax({paused:true});
   creative.tl.addLabel('start')
        .to(creative.dom.preloadShape, 1, {autoAlpha:0})
        .set(creative.dom.barTop, {autoAlpha:0.9, ease: Linear.easeNone}, 'start')
        .set(creative.dom.barBot, {autoAlpha:0.9, ease: Linear.easeNone}, 'start')  
        .addPause()

    .addLabel('label1')         
        .to(creative.dom.text1, 0.3, {autoAlpha:1, ease: Linear.easeNone}, 'label1')
        .addPause()
    .addLabel('label2')  
        .to(creative.dom.text1, 0.3, {autoAlpha:0, ease: Linear.easeNone}, 'label2')        
        .addPause() 
    .addLabel('label3')  
        .to(creative.dom.text2, 0.3, {autoAlpha:1, ease: Linear.easeNone}, 'label3')        
        .addPause()
   .addLabel('label4')  
        .to(creative.dom.text2, 0.3, {autoAlpha:0, ease: Linear.easeNone}, 'label4')        
        .addPause()   
   .addLabel('label5')
        .to(creative.dom.text3, 0.3, {autoAlpha:1, ease: Linear.easeNone}, 'label5')
        .to(creative.dom.cta, 0.3, {autoAlpha:1, ease: Linear.easeNone}, 'label5')  
        .to(creative.dom.tc, 0.3, {autoAlpha:1, ease: Linear.easeNone}, 'label5')  
        .to(creative.dom.barBot, 0.3, {y:20, ease: Linear.easeNone}, 'label5')
        .to(creative.dom.barTop, 0.3, {y:-20, ease: Linear.easeNone}, 'label5')
        .to(creative.dom.logo, 0.3, {autoAlpha:0, ease: Linear.easeNone}, 'label5')
        .call(flagAnimation, null, null);
}


function exitClickHandler() {
  // Reset video
  creative.dom.video0.vid.pause();
  if (creative.dom.video0.vid.readyState > 0) {
    creative.dom.video0.vid.currentTime = videoLength;
   creative.tl.seek(creative.tl.duration(), false);
   creative.dom.poster.style.opacity = 1;
   creative.dom.logoContainer.style.opacity = 0;
   creative.dom.logoEnd.style.opacity = 1;

  }
  Enabler.exit('BackgroundExit');
}


function posterExitClickHandler() {
  // Reset video

  Enabler.exit('BackgroundExit');
}
/**
 * Triggered once the video player is ready to play the video.
 */
function startMuted0(e) {
  // Leaving the listener can cause issues on Chrome / Firefox
  if (creative.dom.video0.hasCanPlay) {
    creative.dom.video0.vid.removeEventListener('canplay', startMuted0);
    creative.dom.video0.hasCanPlay = false;
  }
  // If paused then play
  creative.dom.video0.vid.volume       = 0; // Muted by default
  creative.dom.video0.vid.currentTime  = 0;
  creative.dom.video0.vid.play();
}

/**
 * Stops the video.
 */
function stopHandler0(e) {
  Enabler.counter("Video 0 stopped", true);
  creative.dom.video0.vid.currentTime = 0;
  creative.dom.video0.vid.pause();
  creative.isClick0 = true;
}

/**
 * Handler triggered when the video has finished playing.
 */
function videoEndHandler0(e) {
  creative.dom.video0.vid.currentTime = videoLength;
  creative.dom.video0.vid.pause();
  creative.isClick0 = true;
  //creative.dom.poster.style.opacity = 1;
}

/**
 * Handler triggered when the video has timeUpdates.

/**
 * Add video metrics to the HTML5 video elements by loading in video module, and assigning to videos.
 */
function addVideoTracking0() {
  // Add in the video files.
  var srcNode = document.createElement('source');

  srcNode = document.createElement('source');
  srcNode.setAttribute('type', 'video/mp4');
  srcNode.setAttribute('src', Enabler.getUrl('video/video.mp4'));
  creative.dom.video0.vid.appendChild(srcNode);

  Enabler.loadModule(studio.module.ModuleId.VIDEO, function() {
    studio.video.Reporter.attach('Video Report 0', creative.dom.video0.vid);
  }.bind(this));
}

/**
 *  Main onload handler
 */
window.addEventListener('load', preInit);