// --------------------------------------------------------------------------------------------------

// SETUP VARIABLES
var standalone = true;
var preloadShape = document.getElementById('preloadShape');
var mainContainer = document.getElementById('main-container');
var kv1 = document.getElementById('kv1');
var kv2 = document.getElementById('kv2');
var kv3 = document.getElementById('kv3');
var text1 = document.getElementById('text1');
var text2 = document.getElementById('text2');
var text3 = document.getElementById('text3');
var endContainer = document.getElementById('end-container');
var endframeTextContainer = document.getElementById('endframeText-container');
var ctaContainer = document.getElementById('cta-container');
var LegalContainer = document.getElementById('legal-container');
var tl = new TimelineMax({paused:true});
// --------------------------------------------------------------------------------------------------
// INITIALISE

window.addEventListener('load', init);

function init() {
	anim();
	//setTimeout(loadConfig, 1000);
}

function delayedStart(){
	console.log('Banner Started');
	console.log('standalone: ' + standalone);
	if (standalone){
		tl.play();
	}
}

function setupElements() {

}


function anim() {

	tl.set(kv2, {scale:1.1})
	tl.addLabel('start', 0)
	tl.to(kv1, 8, {scale:1.15,  force3D:false, rotation:0.01, y:-10, ease: Power3.easeOut}, 'start+=1')
	tl.to(preloadShape, 0.5, {autoAlpha:0}, 'start+=1')

	tl.addLabel('frame2', 4)
	tl.to(kv1, 0.3, {autoAlpha:0}, 'frame2+=0.5')
	tl.to(text1, 0.3, {autoAlpha:0}, 'frame2+=0.5')
	tl.from(text2, 0.3, {autoAlpha:0}, 'frame2+=0.8' )
	tl.to(kv2, 8, {scale:1.0,  force3D:false, rotation:0.01,  ease: Power3.easeOut}, 'frame2+=0.5')

	tl.addLabel('frame3', 8)
	tl.to(kv2, 0.3, {autoAlpha:0}, 'frame3+=0.5')
	tl.to(text2, 0.3, {autoAlpha:0}, 'frame3+=0.5')
	tl.from(text3, 0.3, {autoAlpha:0}, 'frame3+=0.8' )
	tl.to(kv3, 12, {scale:1.2, force3D:false, rotation:0.01, y:2, ease: Power3.easeOut}, 'frame3+=0.5')

	tl.addLabel('frame4', 11)
	tl.to(endContainer, 1.5, {clip:'rect(0px,300px,250px,0px)', ease:Expo.easeInOut}, 'frame4')
	tl.to(text3, 0.5, {autoAlpha:0}, 'frame4' )
	tl.from([endframeTextContainer, ctaContainer, LegalContainer], 0.5, {autoAlpha:0}, 'frame4+=1.5')

	tl.to(ctaContainer, 0.5, {alpha:0.8}, 'frame4+=2.2')
	tl.to(ctaContainer, 0.5, {alpha:1}, 'frame4+=2.8')
	
	

	setTimeout(delayedStart, 100);
	
}

// EVENT LISTENERS

function addListeners() {
	console.log('[Added] Event Listeners');

	//var termsBtn = document.getElementById('legal_copy');
	//var termsContainer = document.getElementById('termsContainer');
	//var termsCopy = document.getElementById('terms_copy');

	mainContainer.addEventListener('click', exitClickHandler);

}

// --------------------------------------------------------------------------------------------------
// EVENT HANDLING

function exitClickHandler() {
	//var clickTag = myFT.getClickTag(1);
	myFT.on("instantads", function(){
		myFT.applyClickTag(myFT.$("body"), 1);
	});
	console.log('BackgroundExit');
}
